package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderRepairDetail;
import com.izouma.awesomeadmin.service.OrderRepairDetailService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/orderRepairDetail")
@RequiresAuthentication
public class OrderRepairDetailController {

    @Autowired
    private OrderRepairDetailService orderRepairDetailService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderRepairDetail record) {
        List<OrderRepairDetail> pp = orderRepairDetailService.getOrderRepairDetailList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getOrderRepairDetail", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderRepairDetail(@RequestParam(required = false, value = "id") String id) {
        OrderRepairDetail data = orderRepairDetailService.getOrderRepairDetailById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderRepairDetail record) {
        OrderRepairDetail data = orderRepairDetailService.getOrderRepairDetail(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderRepairDetail record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderRepairDetail> pp = orderRepairDetailService.getOrderRepairDetailByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderRepairDetail record) {
        boolean num = orderRepairDetailService.createOrderRepairDetail(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderRepairDetail(OrderRepairDetail record) {
        boolean num = orderRepairDetailService.updateOrderRepairDetail(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderRepairDetail(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderRepairDetailService.deleteOrderRepairDetail(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderRepairDetail record) throws Exception {

        List<OrderRepairDetail> orderRepairDetails = orderRepairDetailService.getOrderRepairDetailList(record);


        String sheetName = "order_repair_detail";
        String titleName = "订单返修详情数据表";
        String fileName = "订单返修详情表";
        int columnNumber = 9;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "返修ID", "图片ID", "备注"};
        String[][] dataList = new String[orderRepairDetails.size()][9];

        for (int i = 0; i < orderRepairDetails.size(); i++) {

            dataList[i][0] = String.valueOf(orderRepairDetails.get(i).getId());
            dataList[i][1] = String.valueOf(orderRepairDetails.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(orderRepairDetails.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(orderRepairDetails.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(orderRepairDetails.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(orderRepairDetails.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(orderRepairDetails.get(i).getRepairId());
            dataList[i][7] = String.valueOf(orderRepairDetails.get(i).getImageId());
            dataList[i][8] = String.valueOf(orderRepairDetails.get(i).getRemark());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }


    /**
     * 导出备注Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportRemark", method = RequestMethod.GET)
    @ResponseBody
    public void exportRemark(HttpServletRequest request, HttpServletResponse response, OrderRepairDetail record) throws Exception {

        List<OrderRepairDetail> orderRepairDetails = orderRepairDetailService.getOrderRepairDetailExportRemark(record);


        String sheetName = "返修备注";
        String titleName = "订单返修详情数据表";
        String fileName = "订单返修详情表";
        int columnNumber = 2;
        int[] columnWidth = {30, 30};
        String[] columnName = {"图片名称", "备注"};
        String[][] dataList = new String[orderRepairDetails.size()][2];

        for (int i = 0; i < orderRepairDetails.size(); i++) {

            dataList[i][0] = String.valueOf(orderRepairDetails.get(i).getImageName());
            dataList[i][1] = StringUtils.isNotEmpty(orderRepairDetails.get(i).getRemark()) ? String.valueOf(orderRepairDetails.get(i).getRemark()) : "";
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }

}

